#include <stdlib.h>
#include <string.h>

#include "CuTest.h"

/* Fun with South American camelids. */

typedef struct {
  char type[8+1];
  char name[16+1];
} camelid_t;

/* Our code is hard-wired to produce an alpaca named Maria ... */

camelid_t *camelid_create(void)
{
  camelid_t *c = malloc(sizeof(camelid_t));

  strcpy(c->type, "alpaca");
  strcpy(c->name, "Maria");

  return c;
}

/* ... which is too bad since what we want is a llama ... */

void test_camelid_create_type(CuTest *tc)
{
  camelid_t *c = camelid_create();

  CuAssertStrEquals(tc, "llama", c->type);
}

/* ... and the llama should be named Pedro. */

void test_camelid_create_name(CuTest *tc)
{
  camelid_t *c = camelid_create();

  CuAssertStrEquals(tc, "Pedro", c->name);
}
   
CuSuite* camelid_GetSuite()
{
  CuSuite* suite = CuSuiteNew();
  SUITE_ADD_TEST(suite, test_camelid_create_type);
  SUITE_ADD_TEST(suite, test_camelid_create_name);
  return suite;
}
