#!/usr/bin/perl

# Boot up a (host local) GNUnet test network.

use strict;

# command line arguments

if ( $#ARGV != 1 ) {
    die "usage: $0 <gnunet-root-directory> <number-of-instances>\n";
}

my $root = $ARGV[0];
my $n = $ARGV[1];

if ( $n > 10 ) {
    die "$0: max number of instances: 10\n";
}

# boot network

foreach my $host ( 1..$n ) {
    my $conf = "$root/run/gnunet-$host.conf";

    unless ( -e $conf ) {
	print "Error: Missing configuration file: $conf\n";
	next;
    }

    my $cmd = "$root/bin/gnunetd -c $conf";

    print "Booting node: $host\n";
    system $cmd;
}
