#!/usr/bin/perl

# Generate per-host configurations from template.

use strict;
use IO::File;

# BEG: configure

my $template = "gnunet-template.conf";

# END: configure

if ( $#ARGV != 0 ) {
    die "usage: $0 <number-of-instances>\n";
}

if ( $ARGV[0] > 10 ) {
    die "$0: max number of instances: 10\n";
}

# generate configuration files

my %seq; # sequences

for ( my $n = 1; $n <= $ARGV[0]; $n++ ) {
    open TEMPLATE, $template
	or die "open failed: $template: $!\n";

    my $conf = "gnunet-$n.conf";

    open CONF, "> $conf"
	or die "open for writing failed: $conf: $!\n";

    while ( <TEMPLATE> ) {
	next if /^\s+$/;
	next if /^\#/;

	s/\$HOST/$n/;

	if ( /\$SEQ:(\d+)/ ) {
	    if ( $seq{$1} ) {
		$seq{$1}++;
	    }
	    else {
		$seq{$1} = $1;
	    }
	    my $port = $seq{$1};
	    s/\$SEQ:$1/$port/;
	}

	print CONF;
    }

    close CONF;
    close TEMPLATE;
}
