#!/usr/bin/perl

# Generate per-host configurations from template.

use strict;
use IO::File;

# BEG: configurables

my $template = "gnunet-template.conf";
my $netconf = "test-network.conf";

# END: configurables

# parse list of hosts from test network configuration

my @hosts;

open NETCONF, $netconf
    or die "open failed: $netconf: $!\n";

while ( <NETCONF> ) {
    next if /^\s+$/;
    next if /^\#/;
    if ( /^hosts\s*=\s*(.+)$/ ) {
	@hosts = split /\s*,\s*/, $1;
    }
}

close NETCONF;

# generate configuration files

foreach my $host ( @hosts ) {
    open TEMPLATE, $template
	or die "open failed: $template: $!\n";

    my $conf = "gnunet-$host.conf";

    open CONF, "> $conf"
	or die "open for writing failed: $conf: $!\n";

    while ( <TEMPLATE> ) {
	next if /^\s+$/;
	next if /^\#/;
	s/\$HOST/$host/;
	print CONF;
    }

    close CONF;
    close TEMPLATE;
}
