#!/usr/bin/perl

# Shutdown a (host local) GNUnet test network.

use strict;

# command line arguments

if ( $#ARGV != 1 ) {
    die "usage: $0 <gnunet-root-directory> <number-of-instances>\n";
}

my $root = $ARGV[0];
my $n = $ARGV[1];

if ( $n > 10 ) {
    die "$0: max number of instances: 10\n";
}

# boot network

foreach my $host ( 1..$n ) {
    my $pidfile = "$root/run/gnunetd-$host.pid";

    unless ( -e $pidfile ) {
	print "Error: Missing pid file: $pidfile\n";
	next;
    }

    my $pid = `cat $pidfile`;

    print "Killing node: $host (pid: $pid)\n";
    kill 15, $pid;
}
