#!/usr/bin/perl

use strict;

if ( $#ARGV != 0 ) {
    printf STDERR "usage: $0 <file>\n";
    exit 1;
}

my ($file) = @ARGV;

my $total;
my $seen;

open FILE, $file
    or die "open failed: $file: $!\n";

while ( <FILE> ) {
    next if /^\s*$/;
    next if /^\#/;

    chomp;

    unless ( $seen ) { # weed name of the person
	$seen = 1;
	next;
    }

    my ($date, $category, $hours, $description) = split /\s+/, $_, 4;

    $description =~ s/_/\\_/g;
    $description =~ s/&/\\&/g;

    printf("\\item[%s (%s, %d h)] %s\n",
	   $date, $category, $hours, $description);

    $total += $hours;
}

close FILE;

printf("\\item[Yhteens] %d tuntia\n", $total);
